/* PWGame */

#import <Cocoa/Cocoa.h>

@class PWController, PWView;

@class Tile;

@interface PWGame : NSObject
{
    IBOutlet PWController *controller;
    IBOutlet PWView *view;
	
	int state;
	NSPoint tile1point;
	NSPoint tile2point;
	NSPoint startPoint;
	NSPoint endPoint;
	bool selectTile1;	// are we selecting first or second tile?
	
	NSMutableArray* linkedPath;	// path from start point of linked tiles
	
	Tile*	board[10][10];
	int score;
	int swaps;		// number of swaps made
	int level;		// the current level
}

-(void)setState:(int)newState;
-(int)state;

-(void)buildBoard;
-(Tile*)tileAtRow:(int)row Column:(int)column;

-(void)cycleTileAtRow:(int)row column:(int)column;

-(bool)setTile1point:(NSPoint)pt;
-(bool)setTile2point:(NSPoint)pt;

-(NSPoint)tile1point;
-(NSPoint)tile2point;

-(void)setSelectTile1:(bool)newState;
-(bool)selectTile1;

-(bool)swapTiles;

-(void)setStartPoint:(NSPoint)pt;
-(NSPoint)startPoint;

-(void)setEndPoint:(NSPoint)pt;
-(NSPoint)endPoint;

-(void)buildPossiblePaths;
-(void)pathCheckTile:(Tile*)checkTile;

-(NSMutableArray*)linkedPath;
-(int)linkedPathCount;
-(Tile*)getLinkedPathAt:(int)index;

-(void)setScore:(int)newScore;
-(void)changeScore:(int)delta;
-(int)score;

-(void)setSwaps:(int)newValue;
-(void)changeSwaps:(int)delta;
-(int)swaps;

-(void)setLevel:(int)newLevel;
-(void)changeLevel:(int)delta;
-(int)level;

@end
